# Copyright 2005, TIG

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

# Name :          DeleteConLinesOnly
# Author :        TIG
# Usage :         Deletes ALL active Construction Lines BUT leaves any Construction Points 
#		  It does NOT delete Construction Lines within Groups or Components
#		  (unlike Edit...) unless you are in an active Group/Component edit...
# Date :          29/10/05
# Type :          Tool
# History:        1.0 first release 29/10/05
#
#                                  
#-----------------------------------------------------------------------------
require 'sketchup.rb'

def deleteConLinesOnly

   model = Sketchup.active_model
   entities = model.active_entities

   model.start_operation "deleteConLinesOnly"

   8.times do |something| ### runs 8 times as entities x 1 can miss out some bits...
     entities.each do |entity|
	if entity.typename == "ConstructionLine"
		entities.erase_entities entity
	end
     end
   end
   
   model.commit_operation
end 

#=============================================================================

if( not file_loaded?("DeleteConLinesOnly.rb"))
    UI.menu("Plugins").add_item("Delete Construction Lines Only") { deleteConLinesOnly }
end
#-----------------------------------------------------------------------------
file_loaded("DeleteConLinesOnly.rb")



