#Author:wikii
#Date:20080301
#Ver:0.01
#description:Build mesh for selection
require "sketchup"

class Meshfy
   def initialize(ent)
      if !ent
         UI.messagebox "PLZ select an entity to meshfy!", MB_OK, "Error!"
         return
      end

      title ="Setting"
      prompts = ["Row", "Column", "Dist","MAX"]
      values = ["15","15","","2500"]
      popups = [nil, nil, nil]
      results = inputbox( prompts, values, popups, title )
      m=results[0].to_i.abs
      n=results[1].to_i.abs
      w=results[2].to_f.abs.mm
      max=results[2].to_i.abs

      m=nil if m==0
      n=nil if n==0
      w=nil if w==0
      max=2500 if max==0

      if !m and !n and !w
         UI.messagebox "PLZ input correct parameter!", MB_OK, "Error!"
         return
      end

      Sketchup.active_model.start_operation  "MAll"
      @ct=0
      @e=Sketchup.active_model.entities
      @group = @e.add_group
      bd= ent.bounds
      p1=Geom::Point3d.new
      p2=Geom::Point3d.new
      p1.x=bd.min.x
      p1.y=bd.min.y
      p1.z=bd.max.z+1
      p2.x=bd.max.x
      p2.y=bd.max.y
      p2.z=bd.max.z+1


      if m and !n and !w
         w=(p2.y-p1.y)/m
      end


      if w
         n=((p2.x-p1.x)/w).ceil
         puts n
         puts m
         m=((p2.y-p1.y)/w).ceil
         @dx=@dy=w
      else
         @dx=(p2.x-p1.x)/n
         @dy=(p2.y-p1.y)/m
      end

      if (m*n)>max
         UI.messagebox "Row X Colum > #{max}!", MB_OK, "Error!"
         return
      end

      dir = [0,0,-1]
      0.upto(n-1){|x|
         0.upto(m-1){|y|
            @ct+=1
            #puts "x=#{x}  y=#{y}"
            Sketchup::set_status_text "#{n}x#{m}  Finished #{@ct*100/(m*n)}%"
            #UI.messagebox "PLZ go!", MB_OK, "Error!"
            pt=Geom::Point3d.new
            pt.x=p1.x+x*@dx
            pt.y=p1.y+y*@dy
            pt.z=p1.z
            aa=get_corners(pt)
            aa=aa.collect{|xx| get_intersection(xx,dir)}

            f=@group.entities.add_face aa[0],aa[1],aa[2]
            hide_edge(f)
            f=@group.entities.add_face aa[0],aa[2],aa[3]
            hide_edge(f)
         }
      }
      Sketchup.active_model.commit_operation

   end
   def get_corners(pt)
      pt1=pt
      pt2=Geom::Point3d.new pt.x+@dx,pt.y,pt.z
      pt3=Geom::Point3d.new pt.x+@dx,pt.y+@dy,pt.z
      pt4=Geom::Point3d.new pt.x,pt.y+@dy,pt.z
      [pt1,pt2,pt3,pt4]
   end
   def get_intersection(ppt,dir)
      tmp=Sketchup.active_model.raytest(ppt,dir).to_a[0]
      if !tmp
         tmp=ppt
         tmp.z=0.mm
      end
      tmp
   end
   def length_2d(edge)
      p1=edge.vertices[0].position
      p2=edge.vertices[1].position
      p2.z=p1.z
      p1.distance p2
   end
   def hide_edge(f)
      $tp=f.edges.collect{|tx| [length_2d(tx),tx]}
      begin
         ttte=f.edges.collect{|tx| [length_2d(tx),tx]}.sort.last[1]
      rescue
         return
      end
      ttte.soft=true
      ttte.smooth=true
   end
end#class

#~ if( not file_loaded?("Meshfy.rb") )
#~ UI.menu("Plugins").add_item("Meshfy") { Meshfy.new(Sketchup.active_model.selection[0]) }
#~ end
#~ file_loaded("Meshfy.rb")




