# Copyright 2004, Rick Wilson 

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

# Name :          pageLayers.rb 1.0
# Description :   update a single layer's visibility for selected page views
# Author :        Rick Wilson
# Usage :         1. Install into the plugins directory or into the 
#                    plugins/examples directory and manually load from
#			   the ruby console "load 'examples/pageLayers.rb'" 
#			   Does NOT allow selection of current layer.
#                 2. Choose "Page Layers" from the Plugins menu.
# Date :          
# Type :          Tool
# History:
#			1.0 (04.May.2005) - first version
# 
require 'sketchup.rb'

class PageLayers

def PageLayers::pageLayers
	model=Sketchup.active_model
	pages=model.pages
	layers=model.layers
	view=model.active_view
	cam=view.camera
	model.start_operation "pageLayers"
	tabs="1"
	2.upto(pages.count) {|x| tabs<<","+x.to_s} if pages.count>1
	lyrs=[]
	layers.each{|l| lyrs.push(l.name)}
	lyrs.delete(model.active_layer.name)
	lyrlist=[lyrs.join("|")]
	vis=%w(隐藏 显示).join("|")
	lists=[vis,lyrlist,'']
	prompts=["隐藏 / 显示","图层名:","页面(，):  "]
	values=["隐藏",lyrs[0],tabs]
	results=inputbox(prompts,values,lists,"在多个页面中更新图层状态")
	if results
		$vis,$layer,$tabs=results
		$tabs=$tabs.split(',')
		$tabs.each do |e|
			view.camera=pages[e.to_i-1].camera if pages[e.to_i-1].use_camera?
			view.invalidate
			lyrs=pages[e.to_i-1].layers
			if lyrs!=[]
				layers.each {|lyr| lyr.visible=true}
				lyrs.each {|lyr| lyr.visible=false}
			end
			layers[$layer].visible=false if $vis=="隐藏"
			layers[$layer].visible=true if $vis=="显示"
			pages[e.to_i-1].update
		end
		view.camera=cam
		view.invalidate
	end
	model.commit_operation
end

end		#END CLASS

#-----------------------------------------------------------------------------
file_loaded("pageLayers.rb")
