﻿#Sketchup.active_model.select_tool TriangleCircle.new "i"
#Sketchup.active_model.select_tool TriangleCircle.new "o"
#       Author:Wikii
#          Date:2008 03 01
#Description:Creat circumcircle or inscribed circle of a triangle

require "sketchup"
class TriangleCircle
   def initialize(st="o")
      @st=st
      activate
   end
   def activate
      @pts=[]
      @begin=nil
      @model=Sketchup.active_model
      @e=Sketchup.active_model.entities
      @ent_len=@e.length
      @ip = Sketchup::InputPoint.new
      @seg=24
      @model.start_operation  "Triangle All"
      Sketchup::set_status_text "Select points"
      Sketchup::set_status_text "Circle Segment:", SB_VCB_LABEL
   end
   def deactivate(view)
      @model.commit_operation
   end
   def del
      e=[]
      @ent_len.upto(@e.length-1) {|x| e<<@e[x]}
      e.each{|x| x.erase! if !x.deleted?}
   end
   def onMouseMove(flags, x, y, view)
      @ip.pick view, x, y
      view.invalidate
      view.tooltip = @ip.tooltip if @ip.valid?
   end
   def onLButtonDown(flags, x, y, view)
      ip=Sketchup::InputPoint.new
      ip.pick view, x, y
      @pts<<ip.position
      @pts.shift if @pts.length>3
      draw_circle
   end

   def onUserText(text, view)
      begin
         tmp=text.to_i
      rescue
         tmp=""
      end
      if tmp!=""
         @seg=tmp
         draw_circle
      end
   end
   def draw_circle
      del if @begin
      if @pts.length==3
         p1=Geom::Point3d.new @pts[0][0],@pts[0][1],@pts[0][2]
         p2=Geom::Point3d.new @pts[1][0],@pts[1][1],@pts[1][2]
         p3=Geom::Point3d.new @pts[2][0],@pts[2][1],@pts[2][2]
         #draw_triangle p1,p2,p3
         triangle_outer_circle p1,p2,p3 if @st.downcase=="o"
         triangle_inner_circle p1,p2,p3 if @st.downcase=="i"
         @begin=true
      end#if
   end
   def draw_triangle p1,p2,p3
      e=Sketchup.active_model.entities
      e.add_line p1,p2
      e.add_line p3,p2
      e.add_line p1,p3
   end

   def triangle_outer_circle(p1,p2,p3,debug=nil)
      e=Sketchup.active_model.entities
      p12=Geom::Point3d.linear_combination 0.5, p1, 0.5, p2
      p23=Geom::Point3d.linear_combination 0.5, p2, 0.5, p3
      p13=Geom::Point3d.linear_combination 0.5, p1, 0.5, p3

      p12p = p12.project_to_line [p23,p13]
      p23p = p23.project_to_line [p13,p12]
      p13p = p13.project_to_line [p23,p12]

      pt = Geom.intersect_line_line([p13,p13p],[p23,p23p])
      e.add_circle pt,(p2-p1)*(p3-p1), pt.distance( p2 ),@seg
   end

   def  triangle_inner_circle(p1,p2,p3,debug=nil)
      e=Sketchup.active_model.entities
      v12=(p2-p1).normalize
      v13=(p3-p1).normalize
      p11=p1+v12+v13

      v21=(p1-p2).normalize
      v23=(p3-p2).normalize
      p22=p2+v21+v23
      pt = Geom.intersect_line_line([p1,p11],[p2,p22])
      line=[p1,p2]
      e.add_circle pt,(p2-p1)*(p3-p1), pt.distance_to_line( line),@seg
   end
 end#class
 
#if( not file_loaded?("Fillet.rb") )
  #UI.menu("Plugins").add_item("Outer CIRCLE") { Sketchup.active_model.select_tool TriangleCircle.new "o" }  
  #UI.menu("Plugins").add_item("Inner CIRCLE") { Sketchup.active_model.select_tool TriangleCircle.new "i" }  
#end
#file_loaded("TriangleCircle.rb")
