require 'sketchup.rb'

def divide_cpoint
model=Sketchup.active_model
@subdivision = 2
model.start_operation "Divide with construction points"
@e=model.selection[0]
@p1= @e.start.position
@p2= @e.end.position
@v=@p1.vector_to @p2
@vlength=@v.length
prompts = ["Segments:"]
values = [@subdivision]
results = inputbox prompts, values, "Divide"
return if not results
@subdivision = results[0]
# Generate points along @v
1.upto(@subdivision-1) do |i|
  @v.length=i*(@vlength/@subdivision)
  model.active_entities.add_cpoint(@p1.offset(@v))
end
model.commit_operation
end

def divide_cpoint_valid_selection
  return true if Sketchup.active_model.selection.length == 1 and Sketchup.active_model.selection[0].typename == "Edge"
end

if not $divide_cpoint_loaded
  UI.add_context_menu_handler do |menu|
    if divide_cpoint_valid_selection
      menu.add_item("Divide with construction points") { divide_cpoint }
    end
  end
end
$divide_cpoint_loaded=true
