require "sketchup.rb"

#
# author : Kannan
# warranty : the usual stuff
# date     : 3/12/2007
#
# Usage : adds 'Start Recording' 'Stop Recording' to plugins menu
#          Select the start recording, then go about modeling as usual. SU will
#          record a jpg image everytime the view is refreshed, ie. whenever an entity added
#          or simply orbit,pan operation is done. You can collect the numbered images and make movie 
#          using 'windows movie maker'.
#
# limitations : Target folder is hard coded, something similar may be already out there.
#

class Recorder
   def initialize
      @index = 0
      @folder="c:/su_jpgs"
      Dir.mkdir(@folder) if not(FileTest.exist?(@folder))
   end

   def nextFrame(view)
      export_images(view)
      return true
   end

  def int_to_string(i,s)
     i=i.to_s
     i.length.upto(s){i="0"+i}
     i
   end   
   #
   #
   #
   def export_images(view)
      if(@time == nil)
	 @time = view.last_refresh_time
      end

      if(view.last_refresh_time != @time)
        
	 view.write_image @folder+ "/"+ int_to_string(@index,5) + ".jpg"
	 @index += 1
	 @time = view.last_refresh_time
      end
   end
end

def start_recording
   @recorder = Recorder.new
   Sketchup.active_model.active_view.animation = @recorder
end

def stop_recording
   Sketchup.active_model.active_view.animation = nil
end


scriptname = File::basename(__FILE__)

unless file_loaded?(scriptname)

   #menu = UI.menu("Plugins")

   #UI.menu("Plugins").add_separator

   #menu.add_item("Start Recording"){start_recording}  
   #menu.add_item("Stop Recording"){stop_recording}  

   #UI.menu("Plugin s").add_separator
end
file_loaded(scriptname)


