require 'Win32.rb'

class Sutool
  attr_reader :sut_addon_cmds
  #main Sutool class will run init_addon when require this file
  def init_addon
    #addon_cmds will be used to add addon buttons in SUTool cmd block.
    @addon_cmds_order=["","λ","ͣ","Ӳ","","ݿ","ָ","Ŀ¼"]
    @addon_cmds={""=>"self.write_html_file","ݿ"=>"backup_shortcuts","ָ"=>"restore_shortcuts","λ"=>"self.mark_position","ͣ"=>"self.park_sutool",""=>"self.purge","Ӳ"=>"self.analyse","Ŀ¼"=>"self.Open_folder"}
  end
  def backup_shortcuts
require "registry.rb"
short=read_shortcuts
re=[]
short.each{|x,y|
x=x.strip
tmp="<<"
tmp<<"C" if x[0,1]=="1"
tmp<<"A" if x[2,1]=="1"
tmp<<"S" if x[4,1]=="1"
tmp<<"--"
tmp<<x[6..-1]
tmp<<">>"
tmp<<y
re<<tmp
}
path=@path+"/ini/shortcuts.txt"
f=File.new(path,"w")
f.puts re.sort
f.close
end
def restore_shortcuts
  require "registry.rb"
  path=@path+"/ini/shortcuts.txt"
  str=IO.readlines(path)
  shortcuts=Hash.new
  str.each{|x|
  x.gsub!(/\n/,"")
   if x=~/\<\<\S*?--\S*?\>\>/
       cut = $&.gsub(/\<\</,"").gsub(/\>\>/,"").split(/--/)
       key=""
       key += cut[0]=~ /C/ ? "1 " : "0 "
       key += cut[0]=~ /A/ ? "1 " : "0 "
       key += cut[0]=~ /S/ ? "1 " : "0 "
       key += cut[1]+ " "
       value= x.gsub(/\<\<\S*?--\S*?\>\>/,"")
       shortcuts[key]=value
     end     
   }
   del_shortcuts
   write_shortcuts shortcuts
 end
  #move unused rb files to unused folder
 def get_su_handle
       require 'win32.rb'
    tmp=Win32.getActiveWindowQ
    tmp1=Win32.getWindowQ(tmp,4)
    tmp1 ? tmp1 : tmp
   end
  def purge
    require 'ftools.rb'
    folder_urb=@path+"/rb/unused"
    folder_uimg=@path+"/img/unused"
    [folder_urb,folder_uimg].each{|x|  Dir.mkdir(x) if !FileTest.exist?(x) }
    rbs=[]
    imgs=[]
    Dir.entries(@path+"/ini").collect{|x| x if x[-4..-1].to_s.downcase ==".ini"}.compact.sort.each{|x|
      IO.readlines(@path+'/ini/'+x).collect{|y|  y if (y.strip! != "" and y[0,1]!='#')}.compact.each{|z|
        #puts z
        z=z.split("|")
        rbs<<z[2]
        #rbs<<
      }
    }
    rbs=rbs & rbs
    rbs.compact!
    rbs.collect!{|x| x.downcase}
    n=0
    Dir.entries(@path+"/rb").collect{|x| x if ["rb","rbs"].include?(x.split(".").last.to_s.downcase)}.compact.sort.each{|x|
      if !rbs.include?( File.basename(x).downcase)
        puts x
        File.copy(@path+"/rb/"+x ,folder_urb)
        File.delete(@path+"/rb/"+x)
        n+=1
      end
    }
    UI.messagebox n.to_s + " files move to RB Unused folder", MB_OK , "SUTool Purge unused program"
  end

  #open the folder where SUTool located
  def Open_folder
    UI.openURL(@path)
  end
  def park_sutool
    hn=Win32.findWindowQ($sut.title)
    desktop_rc=Win32.getWindowRectQ(Win32.getDesktopWindowQ)
    sutool_rc=Win32.getWindowRectQ(hn)
    if sutool_rc[0]>(desktop_rc[2]/2)
      Win32.setWindowPosQ(hn,0,sutool_rc[1],sutool_rc[2],sutool_rc[3])
    else
      Win32.setWindowPosQ(hn,desktop_rc[2]-sutool_rc[2],sutool_rc[1],sutool_rc[2],sutool_rc[3])
    end
    mark_position
  end
  def mark_position
    hn=Win32.findWindowQ($sut.title)
    sutool_rc=Win32.getWindowRectQ(hn)
    Sketchup.write_default @reg_key,"pos_l",sutool_rc[0].to_i
    Sketchup.write_default @reg_key,"pos_t",sutool_rc[1].to_i
    Sketchup.write_default @reg_key,"pos_w",sutool_rc[2].to_i
    Sketchup.write_default @reg_key,"pos_h",sutool_rc[3].to_i
 end
  #analyse new Rb and add it to ini file
  def analyse
    require 'convert.rb'
    require 'ftools.rb'
    file_name = UI.openpanel("Find a RB file", nil,"*.rb")
    puts file_name
    cmd_str=""
    cmds=[]
    puts File.basename(file_name)
    if file_name
      file_name=sutool_convert_string(file_name)#ת
      f=File.open(file_name)
      f_lines=f.readlines
      x= f_lines.join("")
      #}.unpack("m").to_s
      if x=~ /eval\s*\%[Qq]\{[\s\S]*\}\.unpack\(\"m\"\)\.to_s/
        #x.gsub!(/\s*eval\s*/,"")
        x=~ /eval\s*\%[Qq]\{[\s\S]*\}\.unpack\(\"m\"\)\.to_s/
        x=$&
        x=~/eval\s*/
        $x=$'
        eval($').split("\n").each{|x|
          #puts x
          if x=~ /[Aa][Dd][Dd]_[Ii][Tt][Ee][Mm].*\(.*\).*\{.*\}/
            tmp_str=x.gsub(/.*[Aa][Dd][Dd]_[Ii][Tt][Ee][Mm].*\(\"/,"").gsub(/\"\).*/,"").strip.gsub(/\|/,"_")
            cmds.push           tmp_str
            cmd_str +="\n"+tmp_str + "|" +x.gsub(/.*[Aa][Dd][Dd]_[Ii][Tt][Ee][Mm].*\(.*\).*\{/,"").gsub(/\}.*/,"").strip+"|"+File.basename(file_name)  + "|" + tmp_str
          end
          if x=~ /UI::Command\.new.*\(.*\).*\{.*\}/
            tmp_str=x.gsub(/.*UI::Command\.new.*\(\"/,"").gsub(/\"\).*/,"").strip.gsub(/\|/,"_")
            cmds.push           tmp_str
            cmd_str +="\n"+tmp_str + "|" +x.gsub(/.*UI::Command\.new.*\(.*\).*\{/,"").gsub(/\}.*/,"").strip+"|"+File.basename(file_name)  + "|" + tmp_str
          end
        }
      end
      f_lines.each{|x|
        x.strip!
        #puts x
        if x=~ /[Aa][Dd][Dd]_[Ii][Tt][Ee][Mm].*\(.*\).*\{.*\}/
          tmp_str=x.gsub(/.*[Aa][Dd][Dd]_[Ii][Tt][Ee][Mm].*\(\"/,"").gsub(/\"\).*/,"").strip.gsub(/\|/,"_")
          cmds.push           tmp_str
          cmd_str +="\n"+tmp_str + "|" +x.gsub(/.*[Aa][Dd][Dd]_[Ii][Tt][Ee][Mm].*\(.*\).*\{/,"").gsub(/\}.*/,"").strip+"|"+File.basename(file_name) + "|" + tmp_str
        end
        if x=~ /UI::Command\.new.*\(.*\).*\{.*\}/
          tmp_str=x.gsub(/.*UI::Command\.new.*\(\"/,"").gsub(/\"\).*/,"").strip.gsub(/\|/,"_")
          cmds.push           tmp_str
          cmd_str +="\n"+tmp_str + "|" +x.gsub(/.*UI::Command\.new.*\(.*\).*\{/,"").gsub(/\}.*/,"").strip+"|"+File.basename(file_name)   + "|" + tmp_str
        end
      }
      f.close
    end
    if cmd_str!=""
      cmd_str=cmd_str.chu_li_yin_hao
      #UI.messagebox "Found following \n" + cmd_str  , MB_OK, "Maybe here is the cmd of the script " +File.basename(file_name)
      ini_files=Dir.entries(@path+"/ini").collect{|x| x if x[-4..-1].to_s.downcase ==".ini"}.compact.sort
      html_string=%Q{
        <html>
        <head>
        <link href="<to_be_subst path>/html/SuTool.css" rel="stylesheet" type="text/css">
        </head>
        <body style="margin-left:20px;">
        <script language="javascript">
        function onOK(str)
        {
          window.location = 'skp:on_ok@'+str;
        }
        </script>
        <br/>
        Found CMDs:<br/>
        <font color="red">
        <to_be_subst cmd_str>
        </font>
        <br><br>
        Add CMD to ini file?<br/>
        <label>To an old ini file:
        <select name="select" id="file1" style="width:150px;">
        <to_be_subst file1>
        </select>
        </label>
        <br/>
        <label>To  a new ini file:
        <input type="text" name="textfield" id="file2"  style="width:150px;"/></label>
        <br/><br/>
        <input type="submit" name="Submit" value="OK" onClick="onOK('ok')"  style="width:135px;" />
        <input type="submit" name="Submit1" value="Cancel" onClick="onOK('cancel')" style="width:135px;"/>
        <br/>
        </body>
        </html>
      }
      ini_files=[""]+ini_files
      file1_html_str=""
      0.upto(ini_files.length-1){|i|
        file1_html_str+=%Q{<option  value="#{ini_files[i]}">#{ini_files[i]}</option>\n}
      }
      html_string.sub!(/<to_be_subst path>/,$sut.path)
      html_string.sub!(/<to_be_subst cmd_str>/,cmds.join("<br/>"))
      html_string.sub!(/<to_be_subst file1>/,file1_html_str)
      dlg = UI::WebDialog.new("Cmds in " + File.basename(file_name) , true,"test", 100, 100, 150, 150, true)
      dlg.set_html (html_string)
      #dlg.set_size 320,200+cmds.length*15
      dlg_h=200+cmds.length*15
      tmp_w=cmds.collect{|x| x.length}.sort.last*6+40
      dlg_w= 320 > tmp_w ? 320 : tmp_w
      dlg.set_size dlg_w,dlg_h
      dlg.add_action_callback("on_ok") do |dialog, parameters|
        puts parameters
        if parameters  == "ok"
          file_name1 = dlg.get_element_value("file1")
          file_name2 = dlg.get_element_value("file2").strip
          #
          ini_file_name=file_name1 if file_name1 !=""
          if file_name2 !=""
            ini_file_name=file_name2
            ini_file_name+= ".ini" if ini_file_name.split(".").last.downcase!="ini"
            index=99
            if not (ini_file_name=~/^\d\d/)
              used_num=ini_files.collect{|x| x[0,2].to_i}
              99.downto(1){|i|
                index=i if not used_num.include?(i)
              }
              ini_file_name= index < 10 ? "0"+index.to_s+ini_file_name : index.to_s+ini_file_name
            end
          end
          puts ini_file_name
          if ini_file_name then#
            puts "begin"
            puts ini_file_name
            f=File.open(@path+"\\ini\\"+sutool_convert_string(ini_file_name),"a")
            cmd_str.split("\n").each{|x|
              puts x
              f.puts x
            }
            f.close
            File.copy(file_name,@path+"\\rb")
            UI.openURL(@path+"\\ini\\"+ini_file_name)
          end
        end
        dialog.close()
      end
      dlg.show{}
    else
      UI.messagebox "Found nothing " , MB_OK, "Maybe here is the cmd of the script " +File.basename(file_name)
    end
  end
end
