# Copyright 2006,  ʦսѧʵҰȨ  http://www.teacherwei.com/ 

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# Name :          label_stray_lines.rb 2.0
# Description :   This script writes a text label on every line end that does not touch
#                 another line.  The text leader points to the tip of the open line or curve.
# Author :        Teacherwei
# Usage :         1. select the part of a drawing that you want analyzed, or, select nothing 
#                 and the whole drawing will be analyzed. 
#                 2. Run "Ѱͷ" from the Plugins menu.
# Date :          16.Sep.2006
# Type :          Imported Drawing Clean-Up Aid
# History:        1.0 (16.Sep.2006) - Second version
#
#                                  
#-----------------------------------------------------------------------------

require 'sketchup.rb' 

class BadDrawing 

def BadDrawing.labelLines 
  allverts  = Array.new 
  lonepoints = Array.new 
  am = Sketchup.active_model        # Sketchup Active Model. 
  se = am.entities                  # Sketchup Entities. 
  ae = am.selection                 # Work with selection, if any... 
  if ae.length == 0 then ae = se end     # ...else work with whole model. 
  ae.each {|e| 
    if  e.class == Sketchup::Edge then   # If this is an edge...  
      e.vertices.each {|v|               # ...loop through its vertices... and 
        if v.edges.length == 1 then lonepoints << v.position end   # ...see if there is only 1 connected edge.
        }
      end   # if 
    } 
  print "There are ", lonepoints.length, " open line segments.\n" 
  am.start_operation "Ѱͷ"        # Encapsulate into a single UNDO operation.
  i=1 
  lonepoints.each {|p| 
    se.add_text(i.to_s << " of " << lonepoints.length.to_s , p, [0,0,5] )    # Add the Text Label. 
    i+=1
    } 
  am.commit_operation                           # End of UNDO capsule. 
  end  # def 

if not file_loaded?("Ѱͷ.rb") then   # Add the function to the Plugins Menu.
  UI.menu("Plugins").add_item("Ѱͷ") { BadDrawing.labelLines }
  end
file_loaded("Ѱͷ.rb")   # Mark the script loaded. 

end    # class 
